<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): General Communication Routines</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">General Communication Routines<div class="ingroups"><a class="el" href="group__comm__module.html">Communication</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Contains general-purpose communication functions for TX/RX and monitoring.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gae2623e3f83f9c72f406cfd93f6156348"><td class="memItemLeft" align="right" valign="top">int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gae2623e3f83f9c72f406cfd93f6156348">TIGLCommunicationFindDevice</a> (uint_fast32_t vtxID, uint_fast32_t totalNumVertices, uint_fast32_t numDevices)</td></tr>
<tr class="memdesc:gae2623e3f83f9c72f406cfd93f6156348"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the owner device of a vertex.  <a href="#gae2623e3f83f9c72f406cfd93f6156348">More...</a><br /></td></tr>
<tr class="separator:gae2623e3f83f9c72f406cfd93f6156348"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga23cfdef6309f15a92a5a79ff1d4e77d8"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga23cfdef6309f15a92a5a79ff1d4e77d8">TIGLCommunicationExistMutationMessages</a> ()</td></tr>
<tr class="memdesc:ga23cfdef6309f15a92a5a79ff1d4e77d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if there exist messages from any source with any tag.  <a href="#ga23cfdef6309f15a92a5a79ff1d4e77d8">More...</a><br /></td></tr>
<tr class="separator:ga23cfdef6309f15a92a5a79ff1d4e77d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadf306c4991fc833186b65c8700815f74"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gadf306c4991fc833186b65c8700815f74">TIGLCommunicationExistMessages</a> ()</td></tr>
<tr class="memdesc:gadf306c4991fc833186b65c8700815f74"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there exist messages from any source with any tag.  <a href="#gadf306c4991fc833186b65c8700815f74">More...</a><br /></td></tr>
<tr class="separator:gadf306c4991fc833186b65c8700815f74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0b62b3e3bd409568170396a2b56e8e1d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga0b62b3e3bd409568170396a2b56e8e1d">TIGLCommunicationExistMessages</a> (int *tag, int *dev, int *messageSize)</td></tr>
<tr class="memdesc:ga0b62b3e3bd409568170396a2b56e8e1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there exist messages from any source with any tag.  <a href="#ga0b62b3e3bd409568170396a2b56e8e1d">More...</a><br /></td></tr>
<tr class="separator:ga0b62b3e3bd409568170396a2b56e8e1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae9386ff69f95193aaeb3f10199979d07"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gae9386ff69f95193aaeb3f10199979d07">TIGLCommunicationExistMessagesFromDev</a> (uint_fast32_t dev)</td></tr>
<tr class="memdesc:gae9386ff69f95193aaeb3f10199979d07"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there exist messages with any tag from a given source device.  <a href="#gae9386ff69f95193aaeb3f10199979d07">More...</a><br /></td></tr>
<tr class="separator:gae9386ff69f95193aaeb3f10199979d07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab848bd17d1170ed31806edb6bea1bd0c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gab848bd17d1170ed31806edb6bea1bd0c">TIGLCommunicationExistMessagesWithTag</a> (int tag)</td></tr>
<tr class="memdesc:gab848bd17d1170ed31806edb6bea1bd0c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there exist messages with a given tag from any source.  <a href="#gab848bd17d1170ed31806edb6bea1bd0c">More...</a><br /></td></tr>
<tr class="separator:gab848bd17d1170ed31806edb6bea1bd0c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab922207328e48b4acef99280809a1475"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gab922207328e48b4acef99280809a1475">TIGLCommunicationExistTaggedMessageFromDev</a> (int tag, uint_fast32_t dev, int_fast32_t *messageSize)</td></tr>
<tr class="memdesc:gab922207328e48b4acef99280809a1475"><td class="mdescLeft">&#160;</td><td class="mdescRight">checks if there exist messages with a given tag from a given source  <a href="#gab922207328e48b4acef99280809a1475">More...</a><br /></td></tr>
<tr class="separator:gab922207328e48b4acef99280809a1475"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga98daaa3a6811aa132b3eef033f518d40"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga98daaa3a6811aa132b3eef033f518d40">TIGLCommunicationWaitMPINonblocking</a> (MPI_Request *req)</td></tr>
<tr class="memdesc:ga98daaa3a6811aa132b3eef033f518d40"><td class="mdescLeft">&#160;</td><td class="mdescRight">Waits for nonblocking tx/rx.  <a href="#ga98daaa3a6811aa132b3eef033f518d40">More...</a><br /></td></tr>
<tr class="separator:ga98daaa3a6811aa132b3eef033f518d40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad6e0b7c20af66cc9645315b1431c5274"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gad6e0b7c20af66cc9645315b1431c5274">TIGLCommunicationTestMPINonblocking</a> (MPI_Request *req, int *tag, int *messageSize)</td></tr>
<tr class="memdesc:gad6e0b7c20af66cc9645315b1431c5274"><td class="mdescLeft">&#160;</td><td class="mdescRight">Tests the status nonblocking tx/rx and return the tag and message size.  <a href="#gad6e0b7c20af66cc9645315b1431c5274">More...</a><br /></td></tr>
<tr class="separator:gad6e0b7c20af66cc9645315b1431c5274"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga01fae9333eb9076db2e160fd0270ca01"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga01fae9333eb9076db2e160fd0270ca01">TIGLCommunicationTestMPINonblocking</a> (MPI_Request *req)</td></tr>
<tr class="memdesc:ga01fae9333eb9076db2e160fd0270ca01"><td class="mdescLeft">&#160;</td><td class="mdescRight">Simple test the status nonblocking tx/rx.  <a href="#ga01fae9333eb9076db2e160fd0270ca01">More...</a><br /></td></tr>
<tr class="separator:ga01fae9333eb9076db2e160fd0270ca01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga263c63472be6e732331906559a138021"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga263c63472be6e732331906559a138021">TIGLCommunicationRecvMPICommand</a> (uint8_t *rxBuf, uint_fast32_t bufSize, int_fast32_t src)</td></tr>
<tr class="memdesc:ga263c63472be6e732331906559a138021"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives a message from a particular src with any tag.  <a href="#ga263c63472be6e732331906559a138021">More...</a><br /></td></tr>
<tr class="separator:ga263c63472be6e732331906559a138021"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa0de7df497fbc1d3663ed3e4f35ea414"><td class="memItemLeft" align="right" valign="top">int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gaa0de7df497fbc1d3663ed3e4f35ea414">TIGLCommunicationRecvMPICommand</a> (uint8_t *rxBuf, uint_fast32_t bufSize, int_fast32_t src, int tag)</td></tr>
<tr class="memdesc:gaa0de7df497fbc1d3663ed3e4f35ea414"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives a message from a particular src with a given tag.  <a href="#gaa0de7df497fbc1d3663ed3e4f35ea414">More...</a><br /></td></tr>
<tr class="separator:gaa0de7df497fbc1d3663ed3e4f35ea414"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga65582846597ef84f4e1a9019bbfdf703"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga65582846597ef84f4e1a9019bbfdf703">TIGLCommunicationRecvMPICommand</a> (uint8_t *rxBuf, int_fast32_t *numMessageBytes)</td></tr>
<tr class="memdesc:ga65582846597ef84f4e1a9019bbfdf703"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives a message with any tag from any source.  <a href="#ga65582846597ef84f4e1a9019bbfdf703">More...</a><br /></td></tr>
<tr class="separator:ga65582846597ef84f4e1a9019bbfdf703"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga131d1cc990db51906a3ea9b1b5cf5c1b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga131d1cc990db51906a3ea9b1b5cf5c1b">TIGLCommunicationRecvMPICommandNonblocking</a> (uint8_t *rxBuf, MPI_Request *req)</td></tr>
<tr class="memdesc:ga131d1cc990db51906a3ea9b1b5cf5c1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives a message with any tag from any source.  <a href="#ga131d1cc990db51906a3ea9b1b5cf5c1b">More...</a><br /></td></tr>
<tr class="separator:ga131d1cc990db51906a3ea9b1b5cf5c1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9a26c06d368cb8a79ef71773993bef89"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga9a26c06d368cb8a79ef71773993bef89">TIGLCommunicationRecvMPICommandNonblocking</a> (uint8_t *rxBuf, int messageSize, int dev, int tag, MPI_Request *req)</td></tr>
<tr class="memdesc:ga9a26c06d368cb8a79ef71773993bef89"><td class="mdescLeft">&#160;</td><td class="mdescRight">Nonblocking function for receiving a message with a tag from a given source.  <a href="#ga9a26c06d368cb8a79ef71773993bef89">More...</a><br /></td></tr>
<tr class="separator:ga9a26c06d368cb8a79ef71773993bef89"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad699725401268bd630f50e0a38823ee4"><td class="memItemLeft" align="right" valign="top">int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gad699725401268bd630f50e0a38823ee4">TIGLCommunicationRecvTaggedMPICommand</a> (uint8_t *rxBuf, int tag)</td></tr>
<tr class="memdesc:gad699725401268bd630f50e0a38823ee4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives a message with any tag from any source.  <a href="#gad699725401268bd630f50e0a38823ee4">More...</a><br /></td></tr>
<tr class="separator:gad699725401268bd630f50e0a38823ee4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaee85762f67e58df275a10d7bececf940"><td class="memItemLeft" align="right" valign="top">int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#gaee85762f67e58df275a10d7bececf940">TIGLCommunicationRecvTaggedMPICommandfromDev</a> (uint8_t *rxBuf, int tag, int dev, int count=MAX_MESSAGE_SIZE)</td></tr>
<tr class="memdesc:gaee85762f67e58df275a10d7bececf940"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives a message with any tag from any source.  <a href="#gaee85762f67e58df275a10d7bececf940">More...</a><br /></td></tr>
<tr class="separator:gaee85762f67e58df275a10d7bececf940"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4fc5e84dbbe91a83f9e9d1a2d5144151"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga4fc5e84dbbe91a83f9e9d1a2d5144151">TIGLCommunicationSendMPICommand</a> (uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t dst, int tag)</td></tr>
<tr class="memdesc:ga4fc5e84dbbe91a83f9e9d1a2d5144151"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends a single message to a particular destination with a given tag.  <a href="#ga4fc5e84dbbe91a83f9e9d1a2d5144151">More...</a><br /></td></tr>
<tr class="separator:ga4fc5e84dbbe91a83f9e9d1a2d5144151"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga55203f293cf194bc1dde2803bdb77bb6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga55203f293cf194bc1dde2803bdb77bb6">TIGLCommunicationSendMPICommandNonblocking</a> (uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t dst, int tag, MPI_Request *req)</td></tr>
<tr class="memdesc:ga55203f293cf194bc1dde2803bdb77bb6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends a non-blocking single message to a particular destination with a given tag.  <a href="#ga55203f293cf194bc1dde2803bdb77bb6">More...</a><br /></td></tr>
<tr class="separator:ga55203f293cf194bc1dde2803bdb77bb6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga86b52a40fdca9693411cd050e41c88f6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__comm__routines.html#ga86b52a40fdca9693411cd050e41c88f6">sendMPIBcast</a> (uint8_t *txBuf, uint_fast32_t bufSize, int_fast32_t src)</td></tr>
<tr class="memdesc:ga86b52a40fdca9693411cd050e41c88f6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends a broadcast message.  <a href="#ga86b52a40fdca9693411cd050e41c88f6">More...</a><br /></td></tr>
<tr class="separator:ga86b52a40fdca9693411cd050e41c88f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>Contains general-purpose communication functions for TX/RX and monitoring. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga86b52a40fdca9693411cd050e41c88f6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int sendMPIBcast </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t&#160;</td>
          <td class="paramname"><em>src</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sends a broadcast message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">src</td><td>source device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gadf306c4991fc833186b65c8700815f74"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationExistMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if there exist messages from any source with any tag. </p>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ga0b62b3e3bd409568170396a2b56e8e1d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationExistMessages </td>
          <td>(</td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>dev</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>messageSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if there exist messages from any source with any tag. </p>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="gae9386ff69f95193aaeb3f10199979d07"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationExistMessagesFromDev </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>dev</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if there exist messages with any tag from a given source device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">&lt;dev&gt;</td><td>source device </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="gab848bd17d1170ed31806edb6bea1bd0c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationExistMessagesWithTag </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if there exist messages with a given tag from any source. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">&lt;tag&gt;</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ga23cfdef6309f15a92a5a79ff1d4e77d8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationExistMutationMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check if there exist messages from any source with any tag. </p>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="gab922207328e48b4acef99280809a1475"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationExistTaggedMessageFromDev </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>dev</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t *&#160;</td>
          <td class="paramname"><em>messageSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>checks if there exist messages with a given tag from a given source </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
    <tr><td class="paramname">dev</td><td>rank source device </td></tr>
    <tr><td class="paramname">messageSize</td><td>pointer to the size of the message in bytes (upon completion). It is not changed if the process is not completed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="gae2623e3f83f9c72f406cfd93f6156348"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int_fast32_t TIGLCommunicationFindDevice </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>vtxID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>totalNumVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numDevices</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes the owner device of a vertex. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vtxID</td><td>Vertex ID </td></tr>
    <tr><td class="paramname">totalNumVertices</td><td>total number of vertices in the whole graph </td></tr>
    <tr><td class="paramname">numDevices</td><td>total number of devices </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the rank of the owner device </dd></dl>

</div>
</div>
<a class="anchor" id="ga263c63472be6e732331906559a138021"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationRecvMPICommand </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t&#160;</td>
          <td class="paramname"><em>src</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receives a message from a particular src with any tag. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size in bytes </td></tr>
    <tr><td class="paramname">src</td><td>the message source device </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the message tag </dd></dl>

</div>
</div>
<a class="anchor" id="gaa0de7df497fbc1d3663ed3e4f35ea414"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int_fast32_t TIGLCommunicationRecvMPICommand </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receives a message from a particular src with a given tag. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size in bytes </td></tr>
    <tr><td class="paramname">src</td><td>the message source device </td></tr>
    <tr><td class="paramname">tag</td><td>the message tag </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size of the message in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="ga65582846597ef84f4e1a9019bbfdf703"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationRecvMPICommand </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t *&#160;</td>
          <td class="paramname"><em>numMessageBytes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receives a message with any tag from any source. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">numMessageBytes</td><td>pointer in which the message size is written </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the message tag </dd></dl>

</div>
</div>
<a class="anchor" id="ga131d1cc990db51906a3ea9b1b5cf5c1b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationRecvMPICommandNonblocking </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MPI_Request *&#160;</td>
          <td class="paramname"><em>req</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receives a message with any tag from any source. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">req</td><td>pointer to MPI_Request object (for nonblocking calls) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>standard return of MPI_Irecv </dd></dl>

</div>
</div>
<a class="anchor" id="ga9a26c06d368cb8a79ef71773993bef89"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationRecvMPICommandNonblocking </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>messageSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dev</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MPI_Request *&#160;</td>
          <td class="paramname"><em>req</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Nonblocking function for receiving a message with a tag from a given source. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">messageSize</td><td>message size in bytes </td></tr>
    <tr><td class="paramname">dev</td><td>device rank </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
    <tr><td class="paramname">req</td><td>pointer to MPI_Request object (for nonblocking calls) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd></dd>
<dd>
standard return of MPI_Irecv </dd></dl>

</div>
</div>
<a class="anchor" id="gad699725401268bd630f50e0a38823ee4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int_fast32_t TIGLCommunicationRecvTaggedMPICommand </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receives a message with any tag from any source. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">tag</td><td>the message tag </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="gaee85762f67e58df275a10d7bececf940"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int_fast32_t TIGLCommunicationRecvTaggedMPICommandfromDev </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dev</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>count</em> = <code>MAX_MESSAGE_SIZE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receives a message with any tag from any source. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>receiver buffer </td></tr>
    <tr><td class="paramname">tag</td><td>the message tag </td></tr>
    <tr><td class="paramname">dev</td><td>the rank of the tranmitting device </td></tr>
    <tr><td class="paramname">count</td><td>maximum size of input message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the message size in bytes </dd></dl>

</div>
</div>
<a class="anchor" id="ga4fc5e84dbbe91a83f9e9d1a2d5144151"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationSendMPICommand </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sends a single message to a particular destination with a given tag. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">dst</td><td>destination device </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga55203f293cf194bc1dde2803bdb77bb6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationSendMPICommandNonblocking </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int_fast32_t&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MPI_Request *&#160;</td>
          <td class="paramname"><em>req</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sends a non-blocking single message to a particular destination with a given tag. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">dst</td><td>destination device </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
    <tr><td class="paramname">req</td><td>pointer to MPI_Request object that is required for nonblocking TX </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gad6e0b7c20af66cc9645315b1431c5274"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationTestMPINonblocking </td>
          <td>(</td>
          <td class="paramtype">MPI_Request *&#160;</td>
          <td class="paramname"><em>req</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>messageSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Tests the status nonblocking tx/rx and return the tag and message size. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">req</td><td>pointer to MPI_request object that was filled with the tx/rx </td></tr>
    <tr><td class="paramname">tag</td><td>pointer to the the tag of the message (upon completion). It is not changed if the process is not completed </td></tr>
    <tr><td class="paramname">messageSize</td><td>pointer to the size of the message in bytes (upon completion). It is not changed if the process is not completed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if process is completed, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ga01fae9333eb9076db2e160fd0270ca01"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool TIGLCommunicationTestMPINonblocking </td>
          <td>(</td>
          <td class="paramtype">MPI_Request *&#160;</td>
          <td class="paramname"><em>req</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Simple test the status nonblocking tx/rx. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">req</td><td>pointer to MPI_request object that was filled with the tx/rx </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if process is completed, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ga98daaa3a6811aa132b3eef033f518d40"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int TIGLCommunicationWaitMPINonblocking </td>
          <td>(</td>
          <td class="paramtype">MPI_Request *&#160;</td>
          <td class="paramname"><em>req</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Waits for nonblocking tx/rx. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">req</td><td>pointer to MPI_request object that was filled with the tx/rx </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if there are messages, false otherwise </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
